/* Read_Header.cc */
#include "Connect2SCF.h"

void Connect2SCF :: Read_Header()
{
	FILE* fp_header;
	char buf[256];
	int i,j;
	int nrp;
	int nc;
	int nsp;
	
	int id_rp_tmp;
	char objname_rp_tmp[256];
	int objnum_rp_tmp;
	char classname_rp_tmp[256];
	char porttype_rp_tmp[256];
	
	char objname_cp_tmp[256];
	char classname_cp_tmp[256];
	
	int id_sp_tmp;
	char objname_sp_tmp1[256];
	char objname_sp_tmp2[10];
	int objnum_sp_tmp;
	char classname_sp_tmp[256];
	char porttype_sp_tmp[256];

	char ec1_tmp[256];
	char ec2_tmp[256];
	char pmt1_tmp[256];
	char pmt2_tmp[256];
	char ist1_tmp[256];
	char ist2_tmp[256];
 
	int timestep_tmp;
	double coordinatex_tmp, coordinatey_tmp;
	double resolutionx_tmp, resolutiony_tmp;

	int dif_r;
	//double wholecatchmentarea;
	//double initialdischarge;
	double manningriver;

	char setagawapmt_tmp[256];
	char setagawaist_tmp[256];

    char initialtime_tmp[256];

	if((fp_header = fopen(header_file, "r")) == NULL){
		printf("Connect2SCF\n");
		printf("Cannot open header SCF file.\n");
		exit(1);
	}
	
	// Numbers part ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
		if(buf[0] == '#' || buf[0] == '[') continue; // ȹԤɤФ
		if(sscanf(buf, "%d", &nrp) != 1){
			printf("Cannot scan the Number of Input Ports in Header file.\n");
			exit(1);
		}
		Num_Of_Receive = nrp;
		break;
	}

	while(fgets(buf, 256, fp_header) != NULL){
		if (buf[0] == '#' || buf[0] == '[') continue; // ȹԤɤФ
		if(sscanf(buf, "%d", &nc) != 1){
			printf("Cannot scan the Number of Components Type in Header file.\n");
			exit(1);
		}
		Num_Of_Comp_Type = nc;
		break;
	}

	while(fgets(buf, 256, fp_header) != NULL){
		if (buf[0] == '#' || buf[0] == '[') continue; // ȹԤɤФ
		if(sscanf(buf, "%d", &nsp) != 1){
			printf("Cannot scan the Number of Output Ports in Header file.\n");
			exit(1);
		}
		Num_Of_Send = nsp;
		break;
	}

	// Memory allocations part ɤ߹

	// [InputPorts]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[InputPorts]\n") != 0) continue; //[InputPorts]ޤ褿
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  for (j = 0; j < Num_Of_Receive; j++){
	    fgets(buf, 256, fp_header);
	    if(sscanf(buf, "%d %s %s %s", &id_rp_tmp, objname_rp_tmp, 
		      classname_rp_tmp, porttype_rp_tmp) != 4){
	      printf("Cannot scan Input Ports in Header file.\n");
	      exit(1);
	    }
	    Id_Rp[j] = id_rp_tmp;
	    // Objname_Rp[j] = objname_rp_tmp; // changed by YT on Mov. 9, 2007
	    strcpy(Objname_Rp[j], objname_rp_tmp);
      // Objnum_Rp[j] = objnum_rp_tmp;
	    // Classname_Rp[j] = classname_rp_tmp;  // changed by YT on Mov. 9, 2007
	    strcpy(Classname_Rp[j], classname_rp_tmp);
	    //Porttype_Rp[j] = porttype_rp_tmp;     // changed by YT on Mov. 9, 2007
	    strcpy(Porttype_Rp[j], porttype_rp_tmp);
	  }
	  break;
	}
	
	// [Components]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[Components]\n") != 0) continue; //[Components]ޤ褿
	  for (j = 0; j < Num_Of_Comp_Type; j++) {
	    fgets(buf, 256, fp_header);
	    if(sscanf(buf, "%s %s", objname_cp_tmp, classname_cp_tmp) != 2){
	      printf("Cannot scan Components in Header file.\n");
	      exit(1);
	    }
	    // Objname_Cp[j] = objname_cp_tmp;   // changed by YT on Mov. 9, 2007
	    strcpy(Objname_Cp[j], objname_cp_tmp);
	    // Classname_Cp[j] = classname_cp_tmp;   // changed by YT on Mov. 9, 2007
	    strcpy(Classname_Cp[j], classname_cp_tmp);
	  }
	  break;
	}

	// [OutputPorts]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[OutputPorts]\n") != 0) continue; //[OutputPorts]ޤ褿
	  for (j = 0; j < Num_Of_Send; j++) {
	    fgets(buf, 256, fp_header);
	    if(sscanf(buf, "%d %s %s %d %s %s", &id_sp_tmp, objname_sp_tmp1, objname_sp_tmp2, 
		      &objnum_sp_tmp, classname_sp_tmp, porttype_sp_tmp) != 6){
	      printf("Cannot scan Send Ports in Header file.\n");
	      exit(1);
	    }
	    Id_Sp[j] = id_sp_tmp;
	    // Objname_Sp1[j] = objname_sp_tmp1;   // changed by YT on Mov. 9, 2007
	    strcpy(Objname_Sp1[j], objname_sp_tmp1);
	    // Objname_Sp2[j] = objname_sp_tmp2;
	    strcpy(Objname_Sp2[j], objname_sp_tmp2);   // changed by YT on Mov. 9, 2007
	    Objnum_Sp[j] = objnum_sp_tmp;
	    //Classname_Sp[j] = classname_sp_tmp;
	    strcpy(Classname_Sp[j], classname_sp_tmp);   // changed by YT on Mov. 9, 2007
	    //Porttype_Sp[j] = porttype_sp_tmp;
	    strcpy(Porttype_Sp[j], porttype_sp_tmp);   // changed by YT on Mov. 9, 2007
	  }
	  break;
	}
	
	// [EdgeConnection]ɤ߹
	rewind(fp_header);
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[EdgeConnection]\n") != 0) continue; //[EdgeConnection]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", ec1_tmp) !=1){
	    printf("Cannot scan Send Ports in Header file.\n");
	    exit(1);
	  }
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", ec2_tmp) !=1){
	    printf("Cannot scan Send Ports in Header file.\n");
	    exit(1);
	  }
	  strcpy(Ec1, ec1_tmp);
	  strcpy(Ec2, ec2_tmp);
	  break;
	}
	
	// [Pmt]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[Pmt]\n") != 0) continue; //[Pmt]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", pmt1_tmp) !=1){
	    printf("Cannot scan Send Ports in Header file.\n");
	    exit(1);
	  }
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", pmt2_tmp) !=1){
	    printf("Cannot scan Send Ports in Header file.\n");
	    exit(1);
	  }
	  strcpy(Pmt1, pmt1_tmp);
	  strcpy(Pmt2, pmt2_tmp);
	  break;
	}
	
	// [Ist]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[Ist]\n") != 0) continue; //[Ist]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", ist1_tmp) !=1){
	    printf("Cannot scan Send Ports in Header file.\n");
	    exit(1);
	  }
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", ist2_tmp) !=1){
	    printf("Cannot scan Send Ports in Header file.\n");
	    exit(1);
	  }
	  strcpy(Ist1, ist1_tmp);
	  strcpy(Ist2, ist2_tmp);
	  break;
	}
	
	// [TimeStep]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[TimeStep]\n") != 0) continue; //[TimeStep]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%d", &timestep_tmp) !=1){
	    printf("Cannot scan Simulation Time Step.\n");
	    exit(1);
	  }
	  Timestep = timestep_tmp;
	  printf("Simulation Time Step : %d\n", Timestep);
	  break;
	}

	// [Rainfall_Coordinate]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[Rainfall_Coordinate]\n") != 0) continue; //[Rainfall_Coordinate]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%lf %lf", &coordinatex_tmp, &coordinatey_tmp) !=2){
	    printf("Cannot scan Rainfall Coordinate in Header file.\n");
	    exit(1);
	  }
	  Rainfall_Coordinatex = coordinatex_tmp;
	  Rainfall_Coordinatey = coordinatey_tmp;
	  printf("Rainfall Coordinate : %lf %lf\n", Rainfall_Coordinatex, Rainfall_Coordinatey);
	  break;
	}

	// [Rainfall_Resolution(m)]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if(strcmp(buf, "[Rainfall_Resolution(m)]\n") != 0) continue; //[Rainfall_Resolution(m)]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%lf %lf", &resolutionx_tmp, &resolutiony_tmp) !=2){
	    printf("Cannot scan Rainfall Resolution in Header file.\n");
	    exit(1);
	  }
	  Rainfall_Resolutionx = resolutionx_tmp;
	  Rainfall_Resolutiony = resolutiony_tmp;
	  printf("Rainfall Resolution : %lf %lf\n", Rainfall_Resolutionx, Rainfall_Resolutiony);
	  break;
	}

	// [ManningRiver]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if (strcmp(buf, "[ManningRiver]\n") != 0) continue; //[ManningRiver]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%lf", &manningriver) !=1){
	    printf("Cannot scan Diffluence file Read or Write in Header file.\n");
	    exit(1);
	  }
	  ManningRiver = manningriver;
          printf("ManningRiver : %lf\n", manningriver);
	  break;
	}
	
	// [Diffluence_file]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if (strcmp(buf, "[Diffluence_file]\n") != 0) continue; //[Diffluence_file]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%d", &dif_r) !=1){
	    printf("Cannot scan Diffluence file Read or Write in Header file.\n");
	    exit(1);
	  }
	  Dif_R = dif_r;
	  break;
	}

	/*
	// [WholeCatchmentArea]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if (strcmp(buf, "[WholeCatchmentArea]\n") != 0) continue; //[WholeCatchmentArea]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%lf", &wholecatchmentarea) !=1){
	    printf("Cannot scan Diffluence file Read or Write in Header file.\n");
	    exit(1);
	  }
	  WholeCatchmentArea = wholecatchmentarea;
          printf("WholeCatchmentArea : %lf\n", WholeCatchmentArea);
	  break;
	}

	// [InitialDischarge]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if (strcmp(buf, "[InitialDischarge]\n") != 0) continue; //[InitialDischarge]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%lf", &initialdischarge) !=1){
	    printf("Cannot scan Diffluence file Read or Write in Header file.\n");
	    exit(1);
	  }
	  InitialDischarge = initialdischarge;
          printf("InitialDischarge : %lf\n", InitialDischarge);
	  break;
	}
	*/

	// [SetagawaPmt]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if (strcmp(buf, "[SetagawaPmt]\n") != 0) continue; //[SetagawaPmt]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", setagawapmt_tmp) !=1){
	    printf("Cannot scan SetagawaPmt.\n");
	    exit(1);
	  }
	  strcpy(SetagawaPmt, setagawapmt_tmp);
          printf("SetagawaPmt : %s\n", SetagawaPmt);
	  break;
	}

	// [SetagawaIst]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if (strcmp(buf, "[SetagawaIst]\n") != 0) continue; //[SetagawaIst]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", setagawaist_tmp) !=1){
	    printf("Cannot scan SetagawaIst.\n");
	    exit(1);
	  }
	  strcpy(SetagawaIst, setagawaist_tmp);
          printf("SetagawaIst : %s\n", SetagawaIst);
	  break;
	}

	// [InitialTime]ɤ߹
	while(fgets(buf, 256, fp_header) != NULL){
	  if (buf[0] == '#') continue; // ȹԤɤФ
	  if (strcmp(buf, "[InitialTime]\n") != 0) continue; //[InitialTime]ޤ褿
	  fgets(buf, 256, fp_header);
	  if(sscanf(buf, "%s", initialtime_tmp) !=1){
	    printf("Cannot scan InitialTime.\n");
	    exit(1);
	  }
	  strcpy(InitialTime, initialtime_tmp);
          printf("InitialTime : %s\n", InitialTime);
	  break;
	}

	printf("Reading Header file is done. \n");
}
