/* Write_SCF */
#include "Connect2SCF.h"
#include <time.h>

void Connect2SCF :: Write_SCF(void)
{
  ofstream oFile(scf_file, ios::out);
  ofstream oFile_p(pmt_file, ios::out);
  ofstream oFile_i(ist_file, ios::out);
  ofstream oFile_d(dif_file, ios::out);
  
  char buf[256];
  int ans;
  int id = 0;
  int j2id[Num_of_Seg];
  int rpu_num[Num_of_Seg];
  int lake_id;
  int i,j,k,l;
  FILE* fp_num_of_edge;
  int found, num_of_edge_tmp, total_edge;
  int num_of_output, outlet_no;
  int count = 0, check, temp;
  int dif_count, diffluence[Num_of_Seg], dif_id[Num_of_Seg];
  int lake_count=0;
  int dif_flag;
  float dif_temp;
  int flag;
  int tmp_seg;
  float tmp_length, tmp_difd, tmp_slope, tmp_width;
  float length, difd, slope, width;
  bool lake_existence;
  int lake_model_id, outputid_lakein, outputid_rainonlake, outputid_lakelevel;
  int outputid_lakeinflow, outputid_lakeoutflow, outputid_lakecond;
  int adder_id;

  lake_existence = false;
  for(j=0; j<Num_of_Seg ; j++) rpu_num[j] = 0;

  // ʬήå
  dif_count = 0;
  if(Num_Of_Comp_Type >= 5){
    for(j = 0; j < Num_of_Seg; j++){
      diffluence[j] = 0;
      if(need_seg[j] != 1) continue;
      for(i = 0; i < sigma_down[j]; i++){
        if(mu_down[j][i] < 0) diffluence[j]++;
      }
      if(diffluence[j] > 1){
        oFile_d << dif_count << " " << seg_no[j] << " " << diffluence[j] << " ";
        dif_count++;
        for(i = 0; i < sigma_down[j]; i++){
        if(mu_down[j][i] < 0){
          oFile_d << -mu_down[j][i] << " ";
        }
      }
      oFile_d << endl;
      }
    }
  }
  
  // Comment part
  oFile << "# " << scf_file
    << "\n# This is a structure configuration file."
      << endl;
  
  // Numbers part
  oFile << "#\n# -----------------------------------------"
    << "\n# Numbers part"
      << "\n# -----------------------------------------"
	<< endl;

  // ǥǥη׻
  if(Num_Of_Comp_Type == 1){
    Num_Of_Components = Num_Of_Need_Seg - Num_Of_Removed;
    Num_Of_Components = Num_Of_Components + 1;    // AdderǥҤȤɲ(modified on Apr 13, 2005)
  }
  else if(Num_Of_Comp_Type == 2){
    Num_Of_Components = (Num_Of_Need_Seg - Num_Of_Removed) * 2;      // о¤θʤ
  }
  else if(Num_Of_Comp_Type >= 4){
    Num_Of_Components = 0;
    for(j=0; j<Num_of_Seg; j++){
      if(need_seg[j] == 1){
        if(sigma_up[j] == -2 && sigma_down[j] == -2){
          Num_Of_Components ++;                   // д
          lake_existence = true;
        }
        else{
          Num_Of_Components = Num_Of_Components + 2;
        }
      }
    }
    if(lake_existence == true) Num_Of_Components += 2; // о²ûǥܸо¾߱ǥ(modified on Aug 10, 2003)
  }
  else{
    printf("Number of Components is : %d\n", Num_Of_Comp_Type);
    printf("Number of Components Type must be either 1 or 2 or 4 or 5 or 6(2).\n");
    exit(1);
  }
  if(Num_Of_Comp_Type >= 5){
    Num_Of_Components = Num_Of_Components + dif_count;  // ʬήǥɲ
  }
  
  if(Num_Of_Comp_Type >= 6 && lake_existence == true) 
           Num_Of_Components++; // ܸо¥ǥ (modified on Aug 14, 2003)

  // ϥݡη׻
  num_of_output = 1;  // ήüήФΤνϥݡ
  for(j=0; j < Num_of_Seg; j++){
    if(need_seg[j] == 1){
      num_of_output++;  // ˰ΨΤνϥݡ
      num_of_output++;  // α̤Τνϥݡ
      num_of_output++;  // ή̤Τνϥݡ
      num_of_output++;  // ή̤Τνϥݡ
      num_of_output++;  // ȯ̤Τνϥݡ
    }
  }

  if(Num_Of_Comp_Type >= 4 && lake_existence == true) num_of_output++;   // о²ûǤνϡʡоή̡
  if(Num_Of_Comp_Type >= 4 && lake_existence == true) num_of_output++;   // о¾߱Ǥν

  if(Num_Of_Comp_Type >= 6 && lake_existence == true) num_of_output++;   // о¥ǥ뤫ο̽
  if(Num_Of_Comp_Type >= 6 && lake_existence == true) num_of_output++;   // о¥ǥ뤫ή̽(оή+о¾߱)
  if(Num_Of_Comp_Type >= 6 && lake_existence == true) num_of_output++;   // о¥ǥ뤫ή̽
  if(Num_Of_Comp_Type >= 6 && lake_existence == true) num_of_output++;   // о¥ǥ뤫


  // Numbers part ν
  oFile << Num_Of_Receive <<"\t# number of receive ports\n"
    << Num_Of_Components <<"\t# number of components\n"
      << 0 <<"\t# number of iterator elements\n"
	<< 0 <<"\t# number of iterator sets\n"
	  << num_of_output <<"\t# number of send ports"
	    << endl;
  
  // Memory allocations part
  oFile << "#\n# -----------------------------------------"
    << "\n# Memory allocations part"
      << "\n# -----------------------------------------"
	<< endl;
  
  // [InputPorts] ν
  oFile << "[InputPorts]\n"
    //	      << "# idnum objname objnum classname porttype" << endl;
    << "# idnum objname classname porttype" << endl;
  for (j = 0; j < Num_Of_Receive; j++){
    oFile << Id_Rp[j] << " " << Objname_Rp[j] << " " 
      << Classname_Rp[j] << " " << Porttype_Rp[j] << endl;
  }
  
  // [Components] ν
  oFile << "[Components]\n"
    << "# idnum objname objnum classname porttype"  << endl;
  
  id = 0;
  if(Num_Of_Comp_Type == 1){
    for (j = 0; j < Num_of_Seg; j++){
      if(need_seg[j] == 1){
        if(sigma_up[j] >= 0 || sigma_down[j] >= 0){     // ƻ(о¤ήƻޤ
          // ή
          oFile << id << " " << Objname_Cp[0] << " " << seg_no[j] << " " << Classname_Cp[0] << endl;
          j2id[j] = id;
          id ++;
        }
        else if(sigma_up[j] == -2 && sigma_down[j] == -2){   // д
          // оή
          oFile << id << " " << Objname_Cp[0] << " " << seg_no[j] << " " << Classname_Cp[0] << endl;
          j2id[j] = id;
          id ++;
        }
        else{
          printf("error in Write_SCF.cc");
          exit(1);
        }
      }
    }
    adder_id = id;
    oFile << adder_id << " " << "adder " << 0 << " Adder " << id << endl;
  }

  else if(Num_Of_Comp_Type >= 2){
    for (j = 0; j < Num_of_Seg; j++){
      if(need_seg[j] == 1){
        if(sigma_up[j] >= 0 || sigma_down[j] >= 0){     // ƻ(о¤ήƻޤ
          // ή
          oFile << id << " " << Objname_Cp[0] << " " << seg_no[j] << " " << Classname_Cp[0] << endl;
          j2id[j] = id;
          id ++;
          // ƻ
          if(sigma_up[j] >= 0){
                temp = 0;
            for (i=0 ; i < sigma_up[j]; i++){
             if(mu_up[j][i] < 0) continue;
         temp++;
            }
            oFile << id << " " << Objname_Cp[1] << " " << seg_no[j] << " " << Classname_Cp[1] << " "
              << temp << " 1" << endl;
            id ++;
            if(sigma_down[j] < 0) lake_count ++;  // sigma_down : о¤ؤή
          }
          else{  // sigma_up顧о¤ή
            oFile << id << " " << Objname_Cp[1] << " " << seg_no[j] << " " << Classname_Cp[1] << " "
              << -sigma_up[j] << " 1" << endl;
            id ++;
          }
        }
        else if(sigma_up[j] == -2 && sigma_down[j] == -2){   // д
          // оή
          oFile << id << " " << Objname_Cp[0] << " " << seg_no[j] << " " << Classname_Cp[0] << endl;
          j2id[j] = id;
          id ++;
          lake_count ++;
        }
        else{
          printf("error in Write_SCF.cc");
          exit(1);
        }
      }
    }
  }

  // о²û
  if(Num_Of_Comp_Type >= 4 & lake_existence == true){
//  ̾θ塤0ή(KinemƱͤνϷ)
    // (modified on Aug 10, 2003) from lake_count to lake_count+1 (+1 ϸо¾߱ǤΤ
//  oFile << id << " " << Objname_Cp[2] << " " << 0 << " " << Classname_Cp[2] << " 0 " << lake_count+1 << endl;  // kinem
//  ̾θ塤ή(AdderνϷ
    // (modified on Aug 10, 2003) from lake_count to lake_count+1 (+1 ϸо¾߱ǤΤ
    oFile << id << " " << Objname_Cp[2] << " " << 0 << " " << Classname_Cp[2] << " " << lake_count+1 << endl;   // adder
    lake_id = id;  // о¤θ
    id++;

    // о¾߱
    oFile << id << " " << Objname_Cp[3] << " " << 0 << " " << Classname_Cp[3] << endl;  // rainOnLake
    id++;
  }
  lake_count = 0;
  
  // ʬή
  if(Num_Of_Comp_Type >= 5){
    i=0;
    for(j = 0; j < Num_of_Seg; j++){
      if(need_seg[j] != 1) continue;
      if(diffluence[j] < 2) continue;
      oFile << id << " " << Objname_Cp[4] << " " << i << " " << Classname_Cp[4] << " " << diffluence[j];
      dif_id[i] = id;
      id++;
      i++;
      if(Dif_R == 0){ // ʬήեɤ߹ޤʤ.
        printf("Seg no. %d is diffluenced into %d reaches. Please input the ratio of flow.\n", seg_no[j], diffluence[j]);
        for(l = 0 ; l < diffluence[j]; l++){
          printf("%d seg : \n", l+1);
          scanf("%f", &dif_temp);
          oFile << " " << dif_temp;
        }
        oFile << endl;
      }
      else{  // ʬήեɤ߹(Dif_R == 1)ɤ߹ʬήΨ񤭽Ф.
        dif_flag = 0;
        for(k = 0; k < Total_Num_Of_Dif; k++){
          if(seg_no[j] == Dif_Num[k]){
            for(l = 0; l < Num_Of_Dif[k]; l++) oFile << " " << Dif_Down_Num[k][l];
            for(l = 0; l < Num_Of_Dif[k]; l++) oFile << " " << Ratio[k][l];
            oFile << endl;
            dif_flag = 1;
            break;
          }
        }
        if(dif_flag == 0){  // ʬήե椫鸫Ĥʤä.
          printf("seg no. %d is diffluenced, but it couldn't be found in diffluenced file.\n", seg_no[j]);
          exit(1);
        }
      }
    }
  }

  // оǡʸо¥ǥ(modified on Aug 14, 2003)
  if(Num_Of_Comp_Type >= 6 & lake_existence == true){
    oFile << id << " " << Objname_Cp[5] << " " << 0 << " " << Classname_Cp[5] << endl;   // Setagawa
    lake_model_id = id;
    id++;
  }

  // [Iterators] ν
  oFile << "[Iterators]" << endl;

  // [OutputPorts] ν
  id = 0;
  oFile << "[OutputPorts]\n"
    << "# idnum objname objnum classname porttype"  << endl;
  for (i = 0; i < Num_of_Seg; i++){
    if(need_seg[i] == 1){
     for (j = 1; j <= 5; j++){   // only j = 1,2,3,4,5 ˰Ψα̡ή̡ή̡ȯ̤νϥݡ 
       //if(Num_Of_Comp_Type != 1 && j == 3 && sigma_up[i] == -2) continue;  // j = 3 ƻή̤񤭽ФݸдȤϽϤʤ(Num_Of_Comp_Type == 1 ξ) -> (ѹ) 
       oFile << id << " " << Objname_Sp1[j] << seg_no[i] << Objname_Sp2[j] << " " << Objnum_Sp[j] 
       << " " << Classname_Sp[j] << " " << Porttype_Sp[j] << endl;
       id++;
      }
    }
  }
  oFile << id << " " << Objname_Sp1[0] << Objname_Sp2[0] << " " << Objnum_Sp[0] // ήüʲѤνϥݡ
    << " " << Classname_Sp[0] << " " << Porttype_Sp[0] << endl;
  outlet_no = id;
  id++;
  
  // о²ûǤνϡʡоή̡
  if(Num_Of_Comp_Type >= 4 & lake_existence == true)
  oFile << id << " " << Objname_Sp1[6] << Objname_Sp2[6] << " " << Objnum_Sp[6]
    << " " << Classname_Sp[6] << " " << Porttype_Sp[6] << endl;
  outputid_lakein = id;
  id++;

  // о¾߱Ǥν
  if(Num_Of_Comp_Type >= 4 & lake_existence == true)
  oFile << id << " " << Objname_Sp1[7] << Objname_Sp2[7] << " " << Objnum_Sp[7]
    << " " << Classname_Sp[7] << " " << Porttype_Sp[7] << endl;
  outputid_rainonlake = id;
  id++;

  // о¥ǥ뤫ο̽
  if(Num_Of_Comp_Type >= 6 & lake_existence == true)
  oFile << id << " " << Objname_Sp1[8] << Objname_Sp2[8] << " " << Objnum_Sp[8]
    << " " << Classname_Sp[8] << " " << Porttype_Sp[8] << endl;
  outputid_lakelevel = id;
  id++;

  // о¥ǥ뤫ή̽
  if(Num_Of_Comp_Type >= 6 & lake_existence == true)
  oFile << id << " " << Objname_Sp1[9] << Objname_Sp2[9] << " " << Objnum_Sp[9]
    << " " << Classname_Sp[9] << " " << Porttype_Sp[9] << endl;
  outputid_lakeinflow = id;
  id++;

  // о¥ǥ뤫ή̽
  if(Num_Of_Comp_Type >= 6 & lake_existence == true)
  oFile << id << " " << Objname_Sp1[10] << Objname_Sp2[10] << " " << Objnum_Sp[10]
    << " " << Classname_Sp[10] << " " << Porttype_Sp[10] << endl;
  outputid_lakeoutflow = id;
  id++;

  // о¥ǥ뤫
  if(Num_Of_Comp_Type >= 6 & lake_existence == true)
  oFile << id << " " << Objname_Sp1[11] << Objname_Sp2[11] << " " << Objnum_Sp[11]
    << " " << Classname_Sp[11] << " " << Porttype_Sp[11] << endl;
  outputid_lakecond = id;
  id++;

  // Register and connect part
  oFile << "# -----------------------------------------"
    << "\n# Register and connect part"
      << "\n# -----------------------------------------"
	<< endl;
  
  // [RegisterIterators] ν
  oFile << "[RegisterIterators]" << endl;
  
  // [ConnectPorts] ν
  oFile << "[ConnectPorts]" << endl;
  
  if(Num_Of_Comp_Type == 1){     // ƻθʤ 
    for (j = 0; j < Num_of_Seg; j++){
      if(need_seg[j] == 1){
        // ü (IDֹϣȤƤ-> ή (üOBJ̾rp OBJֹ桧0
        //    ߱
        //    ȯ
        oFile << "r " << 0 << " c " << j2id[j] << " rp " << 0 << endl;
        oFile << "r " << 1 << " c " << j2id[j] << " evp " << 0 << endl;
        
        // ή (üOBJ̾sp OBJֹ桧0-> û (üOBJ̾rp
        //    ̤ήФû
        oFile << "c " << j2id[j] << " sp " << 0 << " c " << adder_id << " rp " << j2id[j] << endl;

        oFile << "c " << j2id[j] << " sp " << "0 " << "s " << count << endl;
        count++;
        oFile << "c " << j2id[j] << " spSarea " << "0 " << "s " << count << endl;
        count++;
        oFile << "c " << j2id[j] << " spStorage " << "0 " << "s " << count << endl;
        count++;
      }
    }
    // û (üOBJ̾sp) ν
    oFile << "c " << adder_id << " sp " << 0 << " s " << count << endl;
  }
  
  if(Num_Of_Comp_Type != 1){     // ƻθ
    dif_count = -1;
    for (j = 0; j < Num_of_Seg; j++){
      if(need_seg[j] == 1){
        if(sigma_up[j] >= 0 && sigma_down[j] >= 0){     // ƻ
          // ü (IDֹϣȤƤ-> ή (üOBJ̾rp OBJֹ桧0
          //    ߱
          //    ȯ
          oFile << "r " << 0 << " c " << j2id[j] << " rp " << 0 << endl;
          oFile << "r " << 1 << " c " << j2id[j] << " evp " << 0 << endl;
          
          // ή (üOBJ̾sp OBJֹ桧0-> ƻ (üOBJ̾rpl OBJֹ桧0
          //    ̤ή
          oFile << "c " << j2id[j] << " sp " << 0 << " c " << j2id[j]+1 << " rpl " << 0 << endl;
          
          // ƻ (üOBJ̾sp OBJֹ桧0-> ή¦ ʬή (üOBJ̾rp OBJֹ桧0
          //    ƻʬήǥή (ʬήθΤߡ
          if(Num_Of_Comp_Type >= 5 && diffluence[j] > 1){
            dif_count ++;
            oFile << "c " << j2id[j]+1 << " sp " << 0 << " c " << dif_id[dif_count] << " rp " << 0 << endl;
          }

          // ƻ (üOBJ̾sp OBJֹ桧0-> ή¦ ƻ (üOBJ̾rpu OBJֹ桧1
          //    ƻή
          check = 0;
          temp = 0;
          if(sigma_down[j] > 0){  // ή¦³
            for(i = 0; i < sigma_down[j]; i++){
              if(mu_down[j][i] < 0){    // ήФƻ
                // ʬήå
                if(check == 1){
                  printf("Notice : Segment No %d is diffluenced.\n", seg_no[j]);                      
                }
                check = 1;
                for(k = 0; k < Num_of_Seg; k++){
                  if(seg_no[k] == -mu_down[j][i]){
                    if(need_seg[k] != 1){ // ή¦βƻneed_seg˴ޤޤƤʤΤǤήüβǽꡥ
                      ans = -1;
                      while(ans != 0 && ans != 1){
                        printf("Is segment No. %d outlet? yes -> 1, no -> 0 (1 or 0) : ", seg_no[j]);
                        scanf("%d",&ans);
                        if(ans == 1){
                          printf("Ok. Segment No. %d is connected to send port (id : %d).\n", seg_no[j], outlet_no);
                          oFile << "c " << j2id[j]+1 << " sp " << "0 " << "s " << outlet_no << endl;
                          break;
                        }
                        else if(ans == 0){
                          printf("Downstream of segment No. %d (%d) is not inside a basin.\n", i, k);
                          exit(1);
                        }
                        else{
                          printf("Please chose 1 or 0.\n");
                        }
                      }
                    }
                    else{
                      // ʬή(üOBJ̾sp , OBJֹ桧0) -> ή¦ ƻ (üOBJ̾rpu , OBJֹ桧1)
                      // (ʬήǤθΤ)
                      if(Num_Of_Comp_Type >= 5 && diffluence[j] > 1){
                        oFile << "c " << dif_id[dif_count] << " sp " << temp << " c " << j2id[k]+1 << " rpu " << rpu_num[k] << endl;
                        rpu_num[k]++;
                        temp++;
                      }
                      else{
                        if(temp > 0)continue;
                        oFile << "c " << j2id[j]+1 << " sp " << 0 << " c " << j2id[k]+1 << " rpu " << rpu_num[k] << endl;
                        rpu_num[k]++;
                        temp++;
                      }
                    }
                  }
                }
              }
            }
            if(check == 0){  //ή¦ήФʤ
              printf("there is no river to discharge at downstream\n");
            }
          }
          else{   //ή¦³Τʤ (sigma_down = 0)
            printf("there is no downstream for river %d\n", seg_no[j]);
            exit(1);
          }
          
          oFile << "c " << j2id[j] << " spSarea " << 0 << " s " << count <<endl;
          count++;
          oFile << "c " << j2id[j] << " spStorage " << 0 << " s " << count <<endl;
          count++;
          oFile << "c " << j2id[j]+1 << " sp " << 0 << " s " << count <<endl;  // ή̤Ϥ
          count++;
          oFile << "c " << j2id[j]   << " sp " << "0 " << "s " << count << endl;  // ή̤Ϥ
          count++;
          oFile << "c " << j2id[j]   << " spEvp " << "0 " << "s " << count << endl;  // ȯ̤Ϥ
          count++;
          
        }    // ƻȤޤ
        
        else if(sigma_up[j] == -2){   // д
          if(sigma_down[j] != -2){
            printf("error in lake segment : %d\n", j2id[j]);
            exit(1);
          }
          // ü (IDֹϣȤƤ-> оľή (üOBJ̾rp OBJֹ桧0t
          //    ߱
          //    ȯ
          oFile << "r " << 0 << " c " << j2id[j] << " rp " << 0 << endl;
          oFile << "r " << 1 << " c " << j2id[j] << " evp " << 0 << endl;
          
          // оľή (üOBJ̾sp OBJֹ桧0-> о (üOBJ̾rp OBJֹ桧rpl
          //    ̤ή
          //   oFile << "c " << j2id[j] << " sp " << 0 << " c " << lake_id << " rpl " << lake_count << endl;  // for kinem
          oFile << "c " << j2id[j] << " sp " << 0 << " c " << lake_id << " rp " << lake_count << endl;  // for adder
          lake_count++;
          
          oFile << "c " << j2id[j] << " spSarea " << "0 " << "s " << count << endl;
          count++;
          oFile << "c " << j2id[j] << " spStorage " << "0 " << "s " << count << endl;
          count++;
          oFile << "c " << j2id[j] << " sp " << 0 << " s " << count <<endl;  // ή(ߡή)Ϥ
          count++;
          oFile << "c " << j2id[j]   << " sp " << "0 " << "s " << count << endl;  // ή̤Ϥ
          count++;
          oFile << "c " << j2id[j]   << " spEvp " << "0 " << "s " << count << endl;  // ȯ̤Ϥ
          count++;
     
        } // дȤޤ
        
        else if(sigma_down[j] == -1){   // оή
          // ü (IDֹϣȤƤ-> ή (üOBJ̾rp OBJֹ桧0
          //    ߱
          //    ȯ
          oFile << "r " << 0 << " c " << j2id[j] << " rp " << 0 << endl;
          oFile << "r " << 1 << " c " << j2id[j] << " evp " << 0 << endl;

          // ή (üOBJ̾sp OBJֹ桧0-> ƻ (üOBJ̾rpl OBJֹ桧0
          //    ̤ή
          oFile << "c " << j2id[j] << " sp " << 0 << " c " << j2id[j]+1 << " rpl " << 0 << endl;
          
          // ƻ (üOBJ̾sp OBJֹ桧0-> о²û (üOBJ̾rpl OBJֹ桧lake_count
          //    о¤ή
          //  oFile << "c " << j2id[j]+1 << " sp " << 0 << " c " << lake_id << " rpl " << lake_count << endl;  // for kinem
          oFile << "c " << j2id[j]+1 << " sp " << 0 << " c " << lake_id << " rp " << lake_count << endl;  // for adder
          lake_count++;
          
          oFile << "c " << j2id[j] << " spSarea " << "0 " << "s " << count << endl;
          count++;
          oFile << "c " << j2id[j] << " spStorage " << "0 " << "s " << count << endl;
          count++;
          oFile << "c " << j2id[j]+1 << " sp " << 0 << " s " << count <<endl;  // ή̤Ϥ
          count++;
          oFile << "c " << j2id[j]   << " sp " << "0 " << "s " << count << endl;  // ή̤Ϥ
          count++;
          oFile << "c " << j2id[j]   << " spEvp " << "0 " << "s " << count << endl;  // ȯ̤Ϥ
          count++;

        } // оήȤޤ
        
        else if(sigma_up[j] == -1){   // оήХ
          // ü (IDֹϣȤƤ-> ή (üOBJ̾rp OBJֹ桧0
          //    ߱
          //    ȯ
          oFile << "r " << 0 << " c " << j2id[j] << " rp " << 0 << endl;
          oFile << "r " << 1 << " c " << j2id[j] << " evp " << 0 << endl;
          
          // ή (üOBJ̾sp OBJֹ桧0-> ƻ (üOBJ̾rpl OBJֹ桧0
          //    ̤ή
          oFile << "c " << j2id[j] << " sp " << 0 << " c " << j2id[j]+1 << " rpl " << 0 << endl;
          
          // ƻ (üOBJ̾sp OBJֹ桧0-> ή¦ ʬή (üOBJ̾rp OBJֹ桧0
          //    ƻʬήǥή (ʬήθΤߡ
          if(Num_Of_Comp_Type >= 5 && diffluence[j] > 1){
            dif_count ++;
            oFile << "c " << j2id[j]+1 << " sp " << 0 << " c " << dif_id[dif_count] << " rp " << 0 << endl;
          }

          // ƻ (üOBJ̾sp OBJֹ桧0-> ƻ (üOBJ̾rpl OBJֹ桧0
          //    ƻή
          check = 0;
          temp = 0;
          if(sigma_down[j] > 0){ // ή¦³
            for(i = 0; i < sigma_down[j]; i++){
              if(mu_down[j][i] < 0){   // ήФƻ
                // ʬήå
                if(check == 1){
                  printf("Notice : Segment No %d is diffluenced.\n", seg_no[j]);
                }
                check = 1;
                for(k = 0; k < Num_of_Seg; k++){
                  if(seg_no[k] == -mu_down[j][i]){
                    if(need_seg[k] != 1){ // ή¦βƻneed_seg˴ޤޤƤʤΤǤήüβǽꡥ
                      ans = -1;
                      while(ans != 0 && ans != 1){
                        printf("Is segment No. %d outlet? yes -> 1, no -> 0 (1 or 0) : ", seg_no[j]);
                        scanf("%d",&ans);
                        if(ans == 1){
                          printf("Ok. Segment No. %d is connected to send port (id : %d).\n ", seg_no[j], outlet_no);
                          oFile << "c " << j2id[j]+1 << " sp " << "0 " << "s " << outlet_no << endl;
                          break;
                        }
                        else if(ans == 0){
                          printf("Downstream of segment No. %d (%d) is not inside a basin.\n", i, k);
                          exit(1);
                        }
                        else{
                          printf("Please chose 1 or 0.\n");
                        }
                      }
                    }
                    else{
                      // ʬή(üOBJ̾sp , OBJֹ桧0) -> ή¦ ƻ (üOBJ̾rpu , OBJֹ桧1)
                      // (ʬήǤθΤ)
                      if(Num_Of_Comp_Type >= 5 && diffluence[j] > 1){
                        oFile << "c " << dif_id[dif_count] << " sp " << temp << " c " << j2id[k]+1 << " rpu " << rpu_num[k] << endl;
                        rpu_num[k]++;
                        temp++;
                      }
                      else{
                        if(temp > 0)continue;
                        oFile << "c " << j2id[j]+1 << " sp " << 0 << " c " << j2id[k]+1 << " rpu " << rpu_num[k] << endl;
                        rpu_num[k]++;
                        temp++;
                      }
                    }
                  }
                }
              }
            }
            if(check == 0){  //ή¦ήФʤ
              printf("there is no river to discharge at downstream\n");
            }
          }
          else{   //ή¦³Τʤ (sigma_down[j] = 0)
            printf("there is no downstream for river %d\n", seg_no[j]);
            exit(1);
          }
          
          oFile << "c " << j2id[j] << " spSarea " << "0 " << "s " << count << endl;
          count++;
          oFile << "c " << j2id[j] << " spStorage " << "0 " << "s " << count << endl;
          count++;
          oFile << "c " << j2id[j]+1 << " sp " << 0 << " s " << count <<endl;  // ή̤Ϥ
          count++;
          oFile << "c " << j2id[j]   << " sp " << "0 " << "s " << count << endl;  // ή̤Ϥ
          count++;
          oFile << "c " << j2id[j]   << " spEvp " << "0 " << "s " << count << endl;  // ȯ̤Ϥ
          count++;
          


          // Num_Of_Comp_Type = 4 or 5 ξ
          // о¤о¥ǥ̤ľή

          if((Num_Of_Comp_Type == 4 || Num_Of_Comp_Type == 5) & lake_existence == true){
            // о²û (üOBJ̾sp OBJֹ桧0-> ƻ (üOBJ̾rpu OBJֹ桧0
            oFile << "c " << lake_id << " sp " << 0 << " c " << j2id[j]+1 << " rpu " << 0 << endl;

            // о²ûǤή̽(оή = оή̡
            oFile << "c " << lake_id << " sp " << "0 " << "s " << outputid_lakein << endl;

          }


          // Num_Of_Comp_Type >= 6 ξ
          // о²ûǤо¥ǥ̤оήХȤή

          if(Num_Of_Comp_Type >= 6 &&  lake_existence == true){
            // о²û (üOBJ̾sp OBJֹ桧0->  о (üOBJ̾rpUp OBJֹ桧0
            oFile << "c " << lake_id << " sp " << 0 << " c " << lake_model_id << " rpUp " << 0 << endl;

            // о²ûǤή̽(оή = оή̡
            oFile << "c " << lake_id << " sp " << "0 " << "s " << outputid_lakein << endl;

            // о (üOBJ̾spDis OBJֹ桧0-> ƻ (üOBJ̾rpu OBJֹ桧0
            oFile << "c " << lake_model_id << " spDis " << 0 << " c " << j2id[j]+1 << " rpu " << 0 << endl;

            // оǤؤι߱
            oFile << "r " << Id_Rp[2] << " c " << lake_model_id << " rpRain " << "0" << endl;

            // оǤؤоݥ
            oFile << "r " << Id_Rp[3] << " c " << lake_model_id << " rpObjCond " << "0" << endl;

            // оǤο̽
            oFile << "c " << lake_model_id << " spWlev " << "0 " << "s " << outputid_lakelevel << endl;

            // оǤή̽
            oFile << "c " << lake_id << " sp " << "0 " << "s " << outputid_lakeinflow << endl;

            // оǤή̽
            oFile << "c " << lake_model_id << " spDis " << "0 " << "s " << outputid_lakeoutflow << endl;

            // оǤ
            oFile << "c " << lake_model_id << " spCond " << "0 " << "s " << outputid_lakecond << endl;
          }

        } // оήХȤޤ
      }
    }
    // (modified on Auguest 10, 2003)
    if(Num_Of_Comp_Type >= 4 & lake_existence == true){
      // о¾߱ (rainOnLakeEvp)
      // ü (IDֹϣȤƤ-> о¾߱ (üOBJ̾rp OBJֹ桧0
      oFile << "r " << 0 << " c " << lake_id+1 << " rp " << 0 << endl;
      // ü (IDֹϣȤƤ-> о¾߱ (üOBJ̾evp OBJֹ桧0
      oFile << "r " << 1 << " c " << lake_id+1 << " evp " << 0 << endl;
      // о¾߱ (üOBJ̾sp , OBJֹ桧0) -> о²û(üOBJ̾rp OBJֹ桧lake_count
      oFile << "c " << lake_id+1 << " sp " << 0 << " c " << lake_id << " rp " << lake_count << endl;   // for rainOnLake -> Adder
      // о¾߱Ǥν
      oFile << "c " << lake_id+1 << " sp " << 0 << " s " << outputid_rainonlake << endl;
    }
  }
  
  // endmark ν
  oFile << "z # end mark" << endl;
  
  // [ConnectComponents] ν
  oFile << "[ConnectComponents]" << endl;
  
  // endmark ν
  oFile << "z # end mark";






  // PMTեν
  
  oFile_p << "# parameter file for SCF-style model building" << endl;
  oFile_p << " " << endl;
  oFile_p << "# TotalSystem Objname Objnum" << endl;
  oFile_p << "ScfTotalSystem total_system 0" << endl;
  oFile_p << "{" << endl;
  
  if( strcmp(Classname_Cp[0], "KsEdgeFc2dEvp") == 0)
  {
    for(j = 0; j < Num_of_Seg; j++){  // KsEdgeFc2dEvpΥѥ᥿ե
      if(need_seg[j] == 1){
        oFile_p << Classname_Cp[0] << " " << Objname_Cp[0] << " " << seg_no[j] << endl;
        oFile_p << Timestep << " " << Ec1 << seg_no[j] << Ec2 << " ";

        // ʬ۹߱ΰ֤ȶʬǽ
        oFile_p << Pmt1 << seg_no[j] << Pmt2 << " " << Rainfall_Coordinatex << " " << Rainfall_Coordinatey << " " << Rainfall_Resolutionx << " " << Rainfall_Resolutiony << endl;
      }
    }
  }
  else if( strcmp(Classname_Cp[0], "Glumpslp2d") == 0)
  {
    for(j = 0; j < Num_of_Seg; j++){  // Glumpslp2dΥѥ᥿ե
      if(need_seg[j] == 1){
        oFile_p << Classname_Cp[0] << " " << Objname_Cp[0] << " " << seg_no[j] << endl;
        oFile_p << "./lump/EC5_250_" << seg_no[j] << ".lump" << " ";
        oFile_p << Ec1 << seg_no[j] << Ec2 << " ";
        // ʬ۹߱ΰ֤ȶʬǽ
        oFile_p << Rainfall_Coordinatex << " " << Rainfall_Coordinatey << " " << Rainfall_Resolutionx << " " << Rainfall_Resolutiony << endl;
      }
    }
  }
  else
  {
    printf("E : Is Classname_Cp[0] : %s right ?", Classname_Cp[0]);
    exit(1);
  }

  if(Num_Of_Comp_Type != 1){
    for(j = 0; j < Num_of_Seg; j++){ // KinemΥѥ᥿ե
      if(need_seg[j] == 1){
        if(sigma_up[j] == -2 && sigma_down[j]) continue;  // оľήˤϲƻ¸ߤʤ

        // ƻĹۤɤ߼
        
        FILE* fp_attr;
        if((fp_attr = fopen(attr_file, "r")) == NULL){
          printf("Connect2SCF\n");
          printf("Cannot open attr file.\n");
          exit(1);
        }

        flag = 0;
        while(flag == 0 && fgets(buf, 256, fp_attr)){
          sscanf(buf, "%d %f %f %f", &tmp_seg, &tmp_length, &tmp_difd, &tmp_slope);
          if(seg_no[j] == tmp_seg){
            flag = 1;
            length = tmp_length;
            difd = tmp_difd;
            slope = tmp_slope;
            if(difd <= 0) slope = 1.0 / length;  // ۤդޤϥκݤɸ⺹mȲꤹ
          }
        }
        if(flag == 0){
          printf("Error : cannot find attribute of riversegment %d.\n", seg_no[j]);
          exit(1);
        }
        fclose(fp_attr);

        // ƻɤ߼

        FILE* fp_width;
        if((fp_width = fopen(width_file, "r")) == NULL){
          printf("Connect2SCF\n");
          printf("Cannot open width file.\n");
          exit(1);
        }
        flag = 0;
        while(flag == 0 && fgets(buf, 256, fp_width)){
          sscanf(buf, "%d %f", &tmp_seg, &tmp_width);
          if(seg_no[j] == tmp_seg){
            flag = 1;
            width = tmp_width;
          }
        }
        if(flag == 0){
          printf("Error : cannot find width of riversegment %d.\n", seg_no[j]);
          exit(1);
        }
        fclose(fp_width);

        // Feb. 26 modified by T.Sayama
        // kinemλȤ˸ȯkinemBϥߡΥѥ᥿Ǥ롥
        // ¼ˤϡR = K*A^(M) ȤƤꡤ̤Ȥ
        // KMꤹ롥Ĺ̤ʤ K = 1/Width, M = 1Ȥ롥

        oFile_p << Classname_Cp[1] << " " << Objname_Cp[1] << " " << seg_no[j] << endl;
        //          L               B               G          Man Div Dt Theta
        //  oFile_p << length << " " << width << " " << slope << " " << ManningRiver << " 20 20 0.65" << endl;  // KinemΥѥ᥿
        oFile_p << length << " " << 1.0 << " " << slope << " " << ManningRiver << " 20 20 0.65" << endl;  // KinemΥѥ᥿
        for(i = 0; i< 21; i++){
          oFile_p << 1.0/width << " ";
        }
        oFile_p << endl;
        for(i = 0; i< 21; i++){
          oFile_p << "1.0 ";
        }
        oFile_p << endl;
      }
    }
  }
  
  // rainOnLakeѥѥ᥿
  // (modified on Aug 10, 2003)
  // "biwalakePoint.dat" ϸоեǤʾܺ٤rainOnLake). ե̾ѹݤϤѹ롥
  if(Num_Of_Comp_Type >= 4 && lake_existence == true){
    oFile_p << Classname_Cp[3] << " " << Objname_Cp[3] << " " << "0" << endl;
       oFile_p << "600 biwalakePoint.dat" << " " << Rainfall_Coordinatex << " " << Rainfall_Coordinatey << " " << Rainfall_Resolutionx << " " << Rainfall_Resolutiony << endl;
  }

  // Setagawaѥѥ᥿
  // (modified on Feb 12, 2004)
  if(Num_Of_Comp_Type >= 6 && lake_existence == true){
    oFile_p << Classname_Cp[5] << " " << Objname_Cp[5] << " " << "0" << endl;
    oFile_p << SetagawaPmt << endl;
  }

  //

  oFile_p << "}" << endl;



  // ISTեν
  oFile_i << "# initial state file for SCF-style model building" << endl;
  oFile_i << " " << endl;
  oFile_i << "# TotalSystem Objname Objnum" << endl;
  oFile_i << "ScfTotalSystem total_system 0" << endl;
  //oFile_i << "0" << endl;
  oFile_i << InitialTime << endl;
  oFile_i << "{" << endl;
  
  if( strcmp(Classname_Cp[0], "KsEdgeFc2dEvp") == 0)
  {
    for(j = 0; j < Num_of_Seg; j++){ // KsEdgeFc2dEvpνե
      if(need_seg[j] == 1){
        oFile_i << Classname_Cp[0] << " " << Objname_Cp[0] << " " << seg_no[j] << endl;
        //oFile_i << 0 << " " << Ist1 << seg_no[j] << Ist2 << endl;
        oFile_i << InitialTime << " " << Ist1 << seg_no[j] << Ist2 << endl;
      }
    }
  }
  else
  {
    printf("E : Is Classname_Cp[0] : %s right ?", Classname_Cp[0]);
    exit(1);
  }

  if(Num_Of_Comp_Type != 1){
    for(j = 0; j < Num_of_Seg; j++){ // Kinemνե
        if(sigma_up[j] == -2 && sigma_down[j]) continue;  // оľήˤϲƻ¸ߤʤ
      if(need_seg[j] == 1){
        oFile_i << Classname_Cp[1] << " " << Objname_Cp[1] << " " << seg_no[j] << endl;
        //oFile_i << "0" << endl;
        oFile_i << InitialTime << endl;
      }
    }
  }

  // rainOnLakeEvp
  if(Num_Of_Comp_Type >= 4 & lake_existence == true){
    oFile_i << Classname_Cp[3] << " " << Objname_Cp[3] << " " << "0" << endl;
    //oFile_i << 0 << endl;
    oFile_i << InitialTime << endl;
  }

  // Setagawa
  if(Num_Of_Comp_Type >= 6 && lake_existence == true){
    oFile_i << Classname_Cp[5] << " " << Objname_Cp[5] << " " << "0" << endl;
    oFile_i << SetagawaIst << endl;
  }

  // Adder
  if(Num_Of_Comp_Type >= 1 && lake_existence == true){
    oFile_i << Classname_Cp[2] << " " << Objname_Cp[2] << " " << "0" << endl;
    //oFile_i << "0" << endl;
    oFile_i << InitialTime << endl;
  }

  // Diver
  if(Num_Of_Comp_Type >= 1){
    for(j = 0; j <= dif_count; j++){
      oFile_i << Classname_Cp[4] << " " << Objname_Cp[4] << " " << j << endl;
      //oFile_i << "0" << endl;
      oFile_i << InitialTime << endl;
    }
  }

  oFile_i << "}" << endl;
}
